using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace CallCenterApi.BLL
{
    /// <summary>
    /// T_Sys_WorkCalendar
    /// </summary>
    public partial class T_Sys_WorkCalendar
    {
        private readonly DAL.T_Sys_WorkCalendar dal = new DAL.T_Sys_WorkCalendar();
        public T_Sys_WorkCalendar()
        { }
        #region  BasicMethod
        /// <summary>
        /// 是否存在该记录
        /// </summary>
        public bool Exists(DateTime F_DateId)
        {
            return dal.Exists(F_DateId);
        }

        /// <summary>
        /// 增加一条数据
        /// </summary>
        public bool Add(Model.T_Sys_WorkCalendar model)
        {
            return dal.Add(model);
        }

        /// <summary>
        /// 更新一条数据
        /// </summary>
        public bool Update(Model.T_Sys_WorkCalendar model)
        {
            return dal.Update(model);
        }

        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool Delete(DateTime F_DateId)
        {

            return dal.Delete(F_DateId);
        }
        /// <summary>
        /// 删除一条数据
        /// </summary>
        public bool DeleteList(string F_DateIdlist)
        {
            return dal.DeleteList(F_DateIdlist);
        }

        /// <summary>
        /// 得到一个对象实体
        /// </summary>
        public Model.T_Sys_WorkCalendar GetModel(DateTime F_DateId)
        {

            return dal.GetModel(F_DateId);
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetList(string strWhere)
        {
            return dal.GetList(strWhere);
        }
        /// <summary>
        /// 获得前几行数据
        /// </summary>
        public DataSet GetList(int Top, string strWhere, string filedOrder)
        {
            return dal.GetList(Top, strWhere, filedOrder);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<Model.T_Sys_WorkCalendar> GetModelList(string strWhere)
        {
            DataSet ds = dal.GetList(strWhere);
            return DataTableToList(ds.Tables[0]);
        }
        /// <summary>
        /// 获得数据列表
        /// </summary>
        public List<Model.T_Sys_WorkCalendar> DataTableToList(DataTable dt)
        {
            List<Model.T_Sys_WorkCalendar> modelList = new List<Model.T_Sys_WorkCalendar>();
            int rowsCount = dt.Rows.Count;
            if (rowsCount > 0)
            {
                Model.T_Sys_WorkCalendar model;
                for (int n = 0; n < rowsCount; n++)
                {
                    model = dal.DataRowToModel(dt.Rows[n]);
                    if (model != null)
                    {
                        modelList.Add(model);
                    }
                }
            }
            return modelList;
        }

        /// <summary>
        /// 获得数据列表
        /// </summary>
        public DataSet GetAllList()
        {
            return GetList("");
        }

        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public int GetRecordCount(string strWhere)
        {
            return dal.GetRecordCount(strWhere);
        }
        /// <summary>
        /// 分页获取数据列表
        /// </summary>
        public DataSet GetListByPage(string strWhere, string orderby, int startIndex, int endIndex)
        {
            return dal.GetListByPage(strWhere, orderby, startIndex, endIndex);
        }



        #endregion  BasicMethod
        #region  ExtensionMethod

        /// <summary>
        /// 获取今天起天数的工作日
        /// </summary>
        /// <param name="day">起止日期</param>
        /// <param name="type">0向前，1向后</param>
        /// <returns></returns>
        public string GetOverDay(string today, string day, int type)
        {
            return dal.GetOverDay(today, day, type);
        }

        #endregion  ExtensionMethod
    }
}
